//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: Simple c++ programs using threads
//
//        ex6.cpp: Printing Hello World
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      g++ ex6.c -o ex6 -pthread
Executing:      ./ex6

Output in my Laptop:

Hello from main 0 Word
Hello from main 1 Word
Hello from main 2 Word
Hello from f1 Word
Hello from f2 Word
End from f1 Word
End from f2 Word

*/

// ***************************************
#include <iostream>
#include <thread>
#include <chrono>

using namespace std ;


// ***************************************
void f2(void)
{
this_thread::sleep_for(chrono::seconds(3));
cout<<"Hello from f2 Word\n" ;
cout<<"End from f2 Word\n" ;
}

// ***************************************
void f1(void)
{
thread th2(f2) ;
th2.detach() ;

cout<<"Hello from f1 Word\n" ;
this_thread::sleep_for(chrono::seconds(1));
cout<<"End from f1 Word\n" ;
}


// ***************************************
int main()
{
thread th1(f1) ;

for( int i = 0 ; i < 3 ; i++ )
	cout<<"Hello from main "<< i <<" Word\n" ;

this_thread::sleep_for(chrono::seconds(6));

if ( th1.joinable())
	th1.join() ;

return 0 ;
}
